Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/async.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,5 +44,5 @@
 #include <sys/time.h>
 #include <atomic.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <task.h>
 
Index: uspace/lib/c/include/atomicdflt.h
===================================================================
--- uspace/lib/c/include/atomicdflt.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/atomicdflt.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,5 +41,5 @@
 
 #include <stdint.h>
-#include <stdbool.h>
+#include <bool.h>
 
 typedef struct atomic {
Index: uspace/lib/c/include/bd_srv.h
===================================================================
--- uspace/lib/c/include/bd_srv.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/bd_srv.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #include <async.h>
 #include <fibril_synch.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 
Index: uspace/lib/c/include/bool.h
===================================================================
--- uspace/lib/c/include/bool.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ uspace/lib/c/include/bool.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_BOOL_H_
+#define LIBC_BOOL_H_
+
+#include <libarch/types.h>
+#include <abi/bool.h>
+
+#define false  0
+#define true   1
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/cfg.h
===================================================================
--- uspace/lib/c/include/cfg.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/cfg.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,5 +41,5 @@
 #include <adt/list.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 /**
Index: uspace/lib/c/include/ddi.h
===================================================================
--- uspace/lib/c/include/ddi.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/ddi.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,7 +36,5 @@
 #define LIBC_DDI_H_
 
-#include <stdbool.h>
 #include <sys/types.h>
-#include <sys/time.h>
 #include <abi/ddi/irq.h>
 #include <task.h>
@@ -52,73 +50,6 @@
 extern int dmamem_unmap_anonymous(void *);
 
+extern int iospace_enable(task_id_t, void *, unsigned long);
 extern int pio_enable(void *, size_t, void **);
-
-typedef void (*trace_fnc)(const volatile void *place, uint32_t val,
-    volatile void* base, size_t size, void *data, bool write);
-
-extern int pio_trace_enable(void *, size_t, trace_fnc, void *);
-extern void pio_trace_log(const volatile void *, uint32_t val, bool write);
-extern void pio_trace_disable(void *);
-
-extern void pio_write_8(ioport8_t *, uint8_t);
-extern void pio_write_16(ioport16_t *, uint16_t);
-extern void pio_write_32(ioport32_t *, uint32_t);
-
-extern uint8_t pio_read_8(const ioport8_t *);
-extern uint16_t pio_read_16(const ioport16_t *);
-extern uint32_t pio_read_32(const ioport32_t *);
-
-static inline uint8_t pio_change_8(
-    ioport8_t *reg, uint8_t val, uint8_t mask, useconds_t delay)
-{
-	uint8_t v = pio_read_8(reg);
-	udelay(delay);
-	pio_write_8(reg, (v & ~mask) | val);
-	return v;
-}
-
-static inline uint16_t pio_change_16(
-    ioport16_t *reg, uint16_t val, uint16_t mask, useconds_t delay)
-{
-	uint16_t v = pio_read_16(reg);
-	udelay(delay);
-	pio_write_16(reg, (v & ~mask) | val);
-	return v;
-}
-
-static inline uint32_t pio_change_32(
-    ioport32_t *reg, uint32_t val, uint32_t mask, useconds_t delay)
-{
-	uint32_t v = pio_read_32(reg);
-	udelay(delay);
-	pio_write_32(reg, (v & ~mask) | val);
-	return v;
-}
-
-static inline uint8_t pio_set_8(ioport8_t *r, uint8_t v, useconds_t d)
-{
-	return pio_change_8(r, v, 0, d);
-}
-static inline uint16_t pio_set_16(ioport16_t *r, uint16_t v, useconds_t d)
-{
-	return pio_change_16(r, v, 0, d);
-}
-static inline uint32_t pio_set_32(ioport32_t *r, uint32_t v, useconds_t d)
-{
-	return pio_change_32(r, v, 0, d);
-}
-
-static inline uint8_t pio_clear_8(ioport8_t *r, uint8_t v, useconds_t d)
-{
-	return pio_change_8(r, 0, v, d);
-}
-static inline uint16_t pio_clear_16(ioport16_t *r, uint16_t v, useconds_t d)
-{
-	return pio_change_16(r, 0, v, d);
-}
-static inline uint32_t pio_clear_32(ioport32_t *r, uint32_t v, useconds_t d)
-{
-	return pio_change_32(r, 0, v, d);
-}
 
 extern int irq_register(int, int, int, irq_code_t *);
Index: uspace/lib/c/include/device/hw_res.h
===================================================================
--- uspace/lib/c/include/device/hw_res.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/device/hw_res.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #include <ipc/dev_iface.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #define DMA_MODE_ON_DEMAND  0
Index: uspace/lib/c/include/devman.h
===================================================================
--- uspace/lib/c/include/devman.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/devman.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <ipc/loc.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 
 extern async_exch_t *devman_exchange_begin_blocking(devman_interface_t);
Index: uspace/lib/c/include/fibril_synch.h
===================================================================
--- uspace/lib/c/include/fibril_synch.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/fibril_synch.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <libarch/tls.h>
 #include <sys/time.h>
-#include <stdbool.h>
+#include <bool.h>
 
 typedef struct {
Index: uspace/lib/c/include/inet/iplink_srv.h
===================================================================
--- uspace/lib/c/include/inet/iplink_srv.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/inet/iplink_srv.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #include <async.h>
 #include <fibril_synch.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 
Index: uspace/lib/c/include/io/charfield.h
===================================================================
--- uspace/lib/c/include/io/charfield.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/charfield.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <io/color.h>
 #include <io/style.h>
Index: uspace/lib/c/include/io/con_srv.h
===================================================================
--- uspace/lib/c/include/io/con_srv.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/con_srv.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,5 +44,5 @@
 #include <io/pixel.h>
 #include <io/style.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/time.h>
 #include <sys/types.h>
Index: uspace/lib/c/include/io/console.h
===================================================================
--- uspace/lib/c/include/io/console.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/console.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,5 +41,5 @@
 #include <io/keycode.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <stdio.h>
 
Index: uspace/lib/c/include/io/klog.h
===================================================================
--- uspace/lib/c/include/io/klog.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/klog.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,5 +42,4 @@
 extern size_t klog_write(const void *, size_t);
 extern void klog_update(void);
-extern void klog_command(const void *, size_t);
 extern int klog_printf(const char *, ...)
     PRINTF_ATTRIBUTE(1, 2);
Index: uspace/lib/c/include/io/pixel.h
===================================================================
--- uspace/lib/c/include/io/pixel.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/pixel.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,6 +42,4 @@
 	((channel) >> (8 - (bits)))
 
-#define INVERT(pixel) ((pixel) ^ 0x00ffffff)
-
 #define ALPHA(pixel)  ((pixel) >> 24)
 #define RED(pixel)    (((pixel) & 0x00ff0000) >> 16)
Index: uspace/lib/c/include/io/pixelmap.h
===================================================================
--- uspace/lib/c/include/io/pixelmap.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/pixelmap.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -52,11 +52,7 @@
     sysarg_t y)
 {
-	if (x < pixelmap->width && y < pixelmap->height) {
-		size_t offset = y * pixelmap->width + x;
-		pixel_t *pixel = pixelmap->data + offset;
-		return pixel;
-	} else {
-		return NULL;
-	}
+	size_t offset = y * pixelmap->width + x;
+	pixel_t *pixel = pixelmap->data + offset;
+	return pixel;
 }
 
Index: uspace/lib/c/include/io/window.h
===================================================================
--- uspace/lib/c/include/io/window.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/io/window.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #define LIBC_IO_WINDOW_H_
 
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 #include <async.h>
@@ -71,6 +71,4 @@
 	ET_POSITION_EVENT,
 	ET_SIGNAL_EVENT,
-	ET_WINDOW_FOCUS,
-	ET_WINDOW_UNFOCUS,
 	ET_WINDOW_RESIZE,
 	ET_WINDOW_REFRESH,
@@ -102,5 +100,5 @@
 } window_grab_flags_t;
 
-extern int win_register(async_sess_t *, service_id_t *, service_id_t *, sysarg_t, sysarg_t);
+extern int win_register(async_sess_t *, service_id_t *, service_id_t *);
 
 extern int win_get_event(async_sess_t *, window_event_t *);
Index: uspace/lib/c/include/ipc/vfs.h
===================================================================
--- uspace/lib/c/include/ipc/vfs.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/ipc/vfs.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #include <ipc/common.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #define FS_NAME_MAXLEN  20
Index: uspace/lib/c/include/loc.h
===================================================================
--- uspace/lib/c/include/loc.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/loc.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #include <ipc/loc.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 
 typedef void (*loc_cat_change_cb_t)(void);
Index: uspace/lib/c/include/macros.h
===================================================================
--- uspace/lib/c/include/macros.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/macros.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,6 +38,4 @@
 #define min(a, b)  ((a) < (b) ? (a) : (b))
 #define max(a, b)  ((a) > (b) ? (a) : (b))
-#define abs(a)     ((a) >= 0 ? (a) : (-a))
-
 
 #define KiB2SIZE(kb)  ((kb) << 10)
@@ -62,10 +60,4 @@
 #endif
 
-#define _paddname(line) PADD_ ## line ## __
-#define _padd(width, line) uint ## width ## _t _paddname(line)
-#define PADD32 _padd(32, __LINE__)
-#define PADD16 _padd(16, __LINE__)
-#define PADD8 _padd(8, __LINE__)
-
 /** @}
  */
Index: uspace/lib/c/include/nic/nic.h
===================================================================
--- uspace/lib/c/include/nic/nic.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/nic/nic.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 
 #include <nic/eth_phys.h>
-#include <stdbool.h>
+#include <bool.h>
 
 /** Ethernet address length. */
Index: uspace/lib/c/include/rtld/dynamic.h
===================================================================
--- uspace/lib/c/include/rtld/dynamic.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/rtld/dynamic.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #define LIBC_RTLD_DYNAMIC_H_
 
-#include <stdbool.h>
+#include <bool.h>
 #include <rtld/elf_dyn.h>
 #include <libarch/rtld/dynamic.h>
Index: uspace/lib/c/include/sort.h
===================================================================
--- uspace/lib/c/include/sort.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/sort.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 typedef int (* sort_cmp_t)(void *, void *, void *);
Index: uspace/lib/c/include/stacktrace.h
===================================================================
--- uspace/lib/c/include/stacktrace.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/stacktrace.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 typedef struct {
Index: uspace/lib/c/include/stats.h
===================================================================
--- uspace/lib/c/include/stats.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/stats.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #include <thread.h>
 #include <stdint.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 #include <abi/sysinfo.h>
Index: uspace/lib/c/include/stdio.h
===================================================================
--- uspace/lib/c/include/stdio.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/stdio.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,4 @@
 #include <str.h>
 #include <io/verify.h>
-#include <abi/klog.h>
 
 #define EOF  (-1)
@@ -52,5 +51,5 @@
 		int _n = snprintf(_buf, sizeof(_buf), fmt, ##__VA_ARGS__); \
 		if (_n > 0) \
-			(void) __SYSCALL3(SYS_KLOG, KLOG_WRITE, (sysarg_t) _buf, str_size(_buf)); \
+			(void) __SYSCALL3(SYS_KLOG, 1, (sysarg_t) _buf, str_size(_buf)); \
 	}
 
Index: uspace/lib/c/include/str.h
===================================================================
--- uspace/lib/c/include/str.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/str.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #include <mem.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #define U_SPECIAL  '?'
Index: uspace/lib/c/include/sys/stat.h
===================================================================
--- uspace/lib/c/include/sys/stat.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/sys/stat.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <ipc/vfs.h>
 #include <ipc/loc.h>
Index: uspace/lib/c/include/sysinfo.h
===================================================================
--- uspace/lib/c/include/sysinfo.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/sysinfo.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <abi/sysinfo.h>
 
Index: uspace/lib/c/include/tls.h
===================================================================
--- uspace/lib/c/include/tls.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/c/include/tls.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -48,8 +48,8 @@
 extern char _tbss_end;
 
-extern tcb_t *tls_make(void);
-extern tcb_t *tls_alloc_arch(void **, size_t);
-extern void tls_free(tcb_t *);
-extern void tls_free_arch(tcb_t *, size_t);
+extern tcb_t *__make_tls(void);
+extern tcb_t *__alloc_tls(void **, size_t);
+extern void __free_tls(tcb_t *);
+extern void __free_tls_arch(tcb_t *, size_t);
 
 #ifdef CONFIG_TLS_VARIANT_1
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/clui/tinput.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <errno.h>
 #include <assert.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <tinput.h>
 
@@ -104,7 +104,5 @@
 static void tinput_display_tail(tinput_t *ti, size_t start, size_t pad)
 {
-	wchar_t *dbuf = malloc((INPUT_MAX_SIZE + 1) * sizeof(wchar_t));
-	if (!dbuf)
-		return;	
+	wchar_t dbuf[INPUT_MAX_SIZE + 1];
 	
 	size_t sa;
@@ -148,6 +146,4 @@
 	
 	console_flush(ti->console);
-
-	free(dbuf);
 }
 
Index: uspace/lib/draw/codec/tga.c
===================================================================
--- uspace/lib/draw/codec/tga.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/codec/tga.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #include <byteorder.h>
 #include <align.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <pixconv.h>
 #include "tga.h"
Index: uspace/lib/draw/drawctx.c
===================================================================
--- uspace/lib/draw/drawctx.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/drawctx.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -129,48 +129,26 @@
 	}
 
-	bool transfer_fast = source_is_fast(context->source)
-	    && (context->shall_clip == false)
-	    && (context->mask == NULL)
-	    && (context->compose == compose_src || context->compose == compose_over);
-
-	if (transfer_fast) {
-
-		for (sysarg_t _y = y; _y < y + height; ++_y) {
-			pixel_t *src = source_direct_access(context->source, x, _y);
-			pixel_t *dst = pixelmap_pixel_at(surface_pixmap_access(context->surface), x, _y);
-			if (src && dst) {
-				sysarg_t count = width;
-				while (count-- != 0) {
-					*dst++ = *src++;
-				}
+	bool clipped = false;
+	bool masked = false;
+
+	for (sysarg_t _y = y; _y < y + height; ++_y) {
+		for (sysarg_t _x = x; _x < x + width; ++_x) {
+			if (context->shall_clip) {
+				clipped = _x < context->clip_x && _x >= context->clip_width
+				    && _y < context->clip_y && _y >= context->clip_height;
+			}
+			
+			if (context->mask) {
+				pixel_t p = surface_get_pixel(context->mask, _x, _y);
+				masked = p > 0 ? false : true;
+			}
+
+			if (!clipped && !masked) {
+				pixel_t p_src = source_determine_pixel(context->source, _x, _y);
+				pixel_t p_dst = surface_get_pixel(context->surface, _x, _y);
+				pixel_t p_res = context->compose(p_src, p_dst);
+				surface_put_pixel(context->surface, _x, _y, p_res);
 			}
 		}
-		surface_add_damaged_region(context->surface, x, y, width, height);
-
-	} else {
-
-		bool clipped = false;
-		bool masked = false;
-		for (sysarg_t _y = y; _y < y + height; ++_y) {
-			for (sysarg_t _x = x; _x < x + width; ++_x) {
-				if (context->shall_clip) {
-					clipped = _x < context->clip_x && _x >= context->clip_width
-					    && _y < context->clip_y && _y >= context->clip_height;
-				}
-
-				if (context->mask) {
-					pixel_t p = surface_get_pixel(context->mask, _x, _y);
-					masked = p > 0 ? false : true;
-				}
-
-				if (!clipped && !masked) {
-					pixel_t p_src = source_determine_pixel(context->source, _x, _y);
-					pixel_t p_dst = surface_get_pixel(context->surface, _x, _y);
-					pixel_t p_res = context->compose(p_src, p_dst);
-					surface_put_pixel(context->surface, _x, _y, p_res);
-				}
-			}
-		}
-
 	}
 }
Index: uspace/lib/draw/drawctx.h
===================================================================
--- uspace/lib/draw/drawctx.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/drawctx.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #include <compose.h>
Index: uspace/lib/draw/path.c
===================================================================
--- uspace/lib/draw/path.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/path.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,5 @@
 
 #include <assert.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <malloc.h>
 
Index: uspace/lib/draw/source.c
===================================================================
--- uspace/lib/draw/source.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/source.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -90,24 +90,4 @@
 }
 
-bool source_is_fast(source_t *source)
-{
-	return (source->mask == NULL)
-	    && (source->alpha == (pixel_t) PIXEL(255, 0, 0, 0))
-	    && (source->texture != NULL)
-	    && (source->texture_tile == false)
-	    && transform_is_fast(&source->transform);
-}
-
-pixel_t *source_direct_access(source_t *source, double x, double y)
-{
-	assert(source_is_fast(source));
-
-	long _x = (long) (x + source->transform.m[0][2]);
-	long _y = (long) (y + source->transform.m[1][2]);
-
-	return pixelmap_pixel_at(
-	    surface_pixmap_access(source->texture), (sysarg_t) _x, (sysarg_t) _y);
-}
-
 pixel_t source_determine_pixel(source_t *source, double x, double y)
 {
Index: uspace/lib/draw/source.h
===================================================================
--- uspace/lib/draw/source.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/source.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #include <transform.h>
@@ -71,6 +71,4 @@
 extern void source_set_mask(source_t *, surface_t *, bool);
 
-extern bool source_is_fast(source_t *);
-extern pixel_t *source_direct_access(source_t *, double, double);
 extern pixel_t source_determine_pixel(source_t *, double, double);
 
Index: uspace/lib/draw/surface.c
===================================================================
--- uspace/lib/draw/surface.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/surface.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -143,17 +143,4 @@
 }
 
-void surface_add_damaged_region(surface_t *surface, surface_coord_t x, surface_coord_t y,
-    surface_coord_t width, surface_coord_t height)
-{
-	surface->dirty_x_lo = surface->dirty_x_lo > x ? x : surface->dirty_x_lo;
-	surface->dirty_y_lo = surface->dirty_y_lo > y ? y : surface->dirty_y_lo;
-
-	surface_coord_t x_hi = x + width - 1;
-	surface_coord_t y_hi = y + height - 1;
-
-	surface->dirty_x_hi = surface->dirty_x_hi < x_hi ? x_hi : surface->dirty_x_hi;
-	surface->dirty_y_hi = surface->dirty_y_hi < y_hi ? y_hi : surface->dirty_y_hi;
-}
-
 void surface_reset_damaged_region(surface_t *surface)
 {
@@ -171,10 +158,16 @@
 	surface->dirty_y_hi = surface->dirty_y_hi < y ? y : surface->dirty_y_hi;
 
-	pixelmap_put_pixel(&surface->pixmap, x, y, pixel);
+	if (x < surface->pixmap.width && y < surface->pixmap.height) {
+		pixelmap_put_pixel(&surface->pixmap, x, y, pixel);
+	}
 }
 
 pixel_t surface_get_pixel(surface_t *surface, surface_coord_t x, surface_coord_t y)
 {
-	return pixelmap_get_pixel(&surface->pixmap, x, y);
+	if (x < surface->pixmap.width && y < surface->pixmap.height) {
+		return pixelmap_get_pixel(&surface->pixmap, x, y);
+	} else {
+		return 0;
+	}
 }
 
Index: uspace/lib/draw/surface.h
===================================================================
--- uspace/lib/draw/surface.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/draw/surface.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <io/pixelmap.h>
 
@@ -61,6 +61,4 @@
 extern void surface_get_damaged_region(surface_t *, surface_coord_t *, surface_coord_t *,
     surface_coord_t *, surface_coord_t *);
-extern void surface_add_damaged_region(surface_t *, surface_coord_t , surface_coord_t ,
-    surface_coord_t , surface_coord_t );
 extern void surface_reset_damaged_region(surface_t *);
 
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/drv/generic/driver.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -45,5 +45,5 @@
 #include <stdio.h>
 #include <errno.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <stdlib.h>
Index: uspace/lib/drv/include/ddf/log.h
===================================================================
--- uspace/lib/drv/include/ddf/log.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/drv/include/ddf/log.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,11 +44,4 @@
     size_t);
 
-#define ddf_log_fatal(msg...) ddf_msg(LVL_FATAL, msg)
-#define ddf_log_error(msg...) ddf_msg(LVL_ERROR, msg)
-#define ddf_log_warning(msg...) ddf_msg(LVL_WARN, msg)
-#define ddf_log_note(msg...) ddf_msg(LVL_NOTE, msg)
-#define ddf_log_debug(msg...) ddf_msg(LVL_DEBUG, msg)
-#define ddf_log_verbose(msg...) ddf_msg(LVL_DEBUG2, msg)
-
 #endif
 
Index: uspace/lib/drv/include/usbhc_iface.h
===================================================================
--- uspace/lib/drv/include/usbhc_iface.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/drv/include/usbhc_iface.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,5 +42,5 @@
 #include "ddf/driver.h"
 #include <usb/usb.h>
-#include <stdbool.h>
+#include <bool.h>
 
 int usbhc_request_address(async_exch_t *, usb_address_t *, bool, usb_speed_t);
Index: uspace/lib/ext2/Makefile
===================================================================
--- uspace/lib/ext2/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ uspace/lib/ext2/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,43 @@
+#
+# Copyright (c) 2005 Martin Decky
+# Copyright (c) 2007 Jakub Jermar
+# Copyright (c) 2010 Martin Sucha
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+LIBRARY = libext2
+EXTRA_CFLAGS = -I$(LIBBLOCK_PREFIX)
+LIBS = $(LIBBLOCK_PREFIX)/libblock.a
+
+SOURCES = \
+	libext2_filesystem.c \
+	libext2_superblock.c \
+	libext2_block_group.c \
+	libext2_inode.c \
+	libext2_directory.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/ext2/libext2.h
===================================================================
--- uspace/lib/ext2/libext2.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ uspace/lib/ext2/libext2.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2011 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libext2
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef LIBEXT2_LIBEXT2_H_
+#define LIBEXT2_LIBEXT2_H_
+
+#include "libext2_superblock.h"
+#include "libext2_block_group.h"
+#include "libext2_inode.h"
+#include "libext2_filesystem.h"
+#include "libext2_directory.h"
+
+#endif
+
+/** @}
+ */
